function [AA, E]=GL(u,N)
e=0.2; %vdp coeffcient
x_max=10;
y_max=10;
dx=2*x_max/(N-1);
dy=2*y_max/(N-1);
dt=1e-2*dx^2;
x=@(i) -x_max+(i-1)*dx;
y=@(j) -y_max+(j-1)*dy;
fp=@(f) max(f,0);
%% Potential function u_1 u_2 
%Linear term (x^2+y^2)/2
Linear=@(i,j) 1/100*(x(i)^4+y(j)^4-10*(x(i)^2+y(j)^2));
F=@(i,j) Linear(i,j);
G=@(i,j) e*log(u(i+N*(j-1)))+Linear(i,j);
E=0; 
for i=1:N
    for j=1:N
        E=G(i,j)*u(i+N*(j-1));
    end
end

%% Matrix A
A=zeros(N^2,N^2);
%Boundary condition
%by approximation e^(2a/e^2)*(r^2/4-r^2/32)
% i=1
for j=2:N-1
   i=1 ;
 % i, j
   A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i+1,j))+fp(F(i,j)-F(i,j+1))+fp(F(i,j)-F(i,j-1)))-3*e;
    % i, j+1
         A(i+(j-1)*N, i+(j+1-1)*N)=fp(F(i,j+1)-F(i,j))+e;
       % i,   j-1
         A(i+(j-1)*N, i+(j-1-1)*N)=fp(F(i,j-1)-F(i,j))+e;
       % i+1, j  
         A(i+(j-1)*N, i+1+(j-1)*N)=fp(F(i+1,j)-F(i,j))+e;
end
% i=N
for j=2:N-1
i=N;  
% i, j 
         A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i-1,j))+fp(F(i,j)-F(i,j+1))+fp(F(i,j)-F(i,j-1)))-3*e;
       % i, j+1
         A(i+(j-1)*N, i+(j+1-1)*N)=fp(F(i,j+1)-F(i,j))+e;
       % i,   j-1
         A(i+(j-1)*N, i+(j-1-1)*N)=fp(F(i,j-1)-F(i,j))+e;
       % i-1, j
         A(i+(j-1)*N, i-1+(j-1)*N)=fp(F(i-1,j)-F(i,j))+e;
end
% j=1
for i=2:N-1
 j=1;
    % i, j 
         A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i+1,j))+fp(F(i,j)-F(i-1,j))+fp(F(i,j)-F(i,j+1)))-3*e;
       % i, j+1
         A(i+(j-1)*N, i+(j+1-1)*N)=fp(F(i,j+1)-F(i,j))+e;
       % i+1, j  
         A(i+(j-1)*N, i+1+(j-1)*N)=fp(F(i+1,j)-F(i,j))+e;
       % i-1, j
         A(i+(j-1)*N, i-1+(j-1)*N)=fp(F(i-1,j)-F(i,j))+e;
end
% j=N
for i=2:N-1
 j=N;
 % i, j 
         A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i+1,j))+fp(F(i,j)-F(i-1,j))+fp(F(i,j)-F(i,j-1)))-3*e;
       % i,   j-1
         A(i+(j-1)*N, i+(j-1-1)*N)=fp(F(i,j-1)-F(i,j))+e;
       % i+1, j  
         A(i+(j-1)*N, i+1+(j-1)*N)=fp(F(i+1,j)-F(i,j))+e;
       % i-1, j
         A(i+(j-1)*N, i-1+(j-1)*N)=fp(F(i-1,j)-F(i,j))+e;
end
%i=1, j=1%

i=1; j=1;     
       % i, j 
         A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i+1,j))+fp(F(i,j)-F(i,j+1)))-2*e;
       % i, j+1
         A(i+(j-1)*N, i+(j+1-1)*N)=fp(F(i,j+1)-F(i,j))+e;
       % i+1, j  
         A(i+(j-1)*N, i+1+(j-1)*N)=fp(F(i+1,j)-F(i,j))+e;
i=1; j=N;
       % i, j 
         A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i+1,j))+fp(F(i,j)-F(i,j-1)))-2*e;
       % i,   j-1
         A(i+(j-1)*N, i+(j-1-1)*N)=fp(F(i,j-1)-F(i,j))+e;
       % i+1, j  
         A(i+(j-1)*N, i+1+(j-1)*N)=fp(F(i+1,j)-F(i,j))+e;
i=N; j=1;
       % i, j 
         A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i-1,j))+fp(F(i,j)-F(i,j+1)))-2*e;
       % i, j+1
         A(i+(j-1)*N, i+(j+1-1)*N)=fp(F(i,j+1)-F(i,j))+e;
       % i-1, j
         A(i+(j-1)*N, i-1+(j-1)*N)=fp(F(i-1,j)-F(i,j))+e;
i=N; j=N;
    
        % i, j 
         A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i-1,j))+fp(F(i,j)-F(i,j-1)))-2*e;
       % i,   j-1
         A(i+(j-1)*N, i+(j-1-1)*N)=fp(F(i,j-1)-F(i,j))+e;
       % i-1, j
         A(i+(j-1)*N, i-1+(j-1)*N)=fp(F(i-1,j)-F(i,j))+e;



%Interior point
for i=2:N-1
    for j=2:N-1    
       % i, j 
         A(i+(j-1)*N, i+(j-1)*N)=-(fp(F(i,j)-F(i+1,j))+fp(F(i,j)-F(i-1,j))+fp(F(i,j)-F(i,j+1))+fp(F(i,j)-F(i,j-1)))-4*e;
       % i, j+1
         A(i+(j-1)*N, i+(j+1-1)*N)=fp(F(i,j+1)-F(i,j))+e;
       % i,   j-1
         A(i+(j-1)*N, i+(j-1-1)*N)=fp(F(i,j-1)-F(i,j))+e;
       % i+1, j  
         A(i+(j-1)*N, i+1+(j-1)*N)=fp(F(i+1,j)-F(i,j))+e;
       % i-1, j
         A(i+(j-1)*N, i-1+(j-1)*N)=fp(F(i-1,j)-F(i,j))+e;
    end
end

AA=sparse(A);
AA=A;
%% u0



% filename=num2str(e);
% save(filename,'F');
% toc

